namespace MapCommaSeparatedValue {
    
    
    [Microsoft.XLANGs.BaseTypes.SchemaReference(@"MapCommaSeparatedValue.MultipleElementsSchema", typeof(MapCommaSeparatedValue.MultipleElementsSchema))]
    [Microsoft.XLANGs.BaseTypes.SchemaReference(@"MapCommaSeparatedValue.CommaSeparatedSchema", typeof(MapCommaSeparatedValue.CommaSeparatedSchema))]
    public sealed class MultipleToComma : Microsoft.XLANGs.BaseTypes.TransformBase {
        
        private const string _strMap = @"<?xml version=""1.0"" encoding=""UTF-16""?>
<xsl:stylesheet xmlns:xsl=""http://www.w3.org/1999/XSL/Transform"" xmlns:msxsl=""urn:schemas-microsoft-com:xslt"" xmlns:var=""http://schemas.microsoft.com/BizTalk/2003/var"" exclude-result-prefixes=""msxsl var s0 userCSharp"" version=""1.0"" xmlns:ns0=""http://MapCommaSeparatedValue.CommaSeparatedSchema"" xmlns:s0=""http://MapCommaSeparatedValue.MultipleElementsSchema"" xmlns:userCSharp=""http://schemas.microsoft.com/BizTalk/2003/userCSharp"">
  <xsl:output omit-xml-declaration=""yes"" method=""xml"" version=""1.0"" />
  <xsl:template match=""/"">
    <xsl:apply-templates select=""/s0:MultipleElementsRoot"" />
  </xsl:template>
  <xsl:template match=""/s0:MultipleElementsRoot"">
    <ns0:CommaSeparatedRoot>
      <xsl:variable name=""var:v1"" select=""userCSharp:InitCumulativeConcat(0)"" />
      <xsl:for-each select=""/s0:MultipleElementsRoot/MyField"">
        <xsl:variable name=""var:v2"" select=""userCSharp:StringConcat(string(./text()) , &quot;,&quot;)"" />
        <xsl:variable name=""var:v3"" select=""userCSharp:AddToCumulativeConcat(0,string($var:v2),&quot;1000&quot;)"" />
      </xsl:for-each>
      <xsl:variable name=""var:v4"" select=""userCSharp:GetCumulativeConcat(0)"" />
      <xsl:variable name=""var:v5"" select=""userCSharp:StringSize(string($var:v4))"" />
      <xsl:variable name=""var:v6"" select=""userCSharp:MathSubtract(string($var:v5) , &quot;1&quot;)"" />
      <xsl:variable name=""var:v7"" select=""userCSharp:StringSubstring(string($var:v4) , &quot;1&quot; , string($var:v6))"" />
      <CommaField>
        <xsl:value-of select=""$var:v7"" />
      </CommaField>
      <xsl:variable name=""var:v8"" select=""userCSharp:InitCumulativeConcat(0)"" />
      <xsl:for-each select=""/s0:MultipleElementsRoot/MyField"">
        <xsl:variable name=""var:v9"" select=""string(./text())"" />
        <xsl:variable name=""var:v10"" select=""userCSharp:StringConcat($var:v9 , &quot;,&quot;)"" />
        <xsl:variable name=""var:v11"" select=""userCSharp:AddToCumulativeConcat(0,string($var:v10),&quot;1000&quot;)"" />
      </xsl:for-each>
      <xsl:variable name=""var:v12"" select=""userCSharp:GetCumulativeConcat(0)"" />
      <xsl:variable name=""var:v13"" select=""userCSharp:RemoveLastComma(string($var:v12))"" />
      <CommaField2>
        <xsl:value-of select=""$var:v13"" />
      </CommaField2>
    </ns0:CommaSeparatedRoot>
  </xsl:template>
  <msxsl:script language=""C#"" implements-prefix=""userCSharp""><![CDATA[
public string InitCumulativeConcat(int index)
{
	if (index >= 0)
	{
		if (index >= myCumulativeConcatArray.Count)
		{
			int i = myCumulativeConcatArray.Count;
			for (; i<=index; i++)
			{
				myCumulativeConcatArray.Add("""");
			}
		}
		else
		{
			myCumulativeConcatArray[index] = """";
		}
	}
	return """";
}

public System.Collections.ArrayList myCumulativeConcatArray = new System.Collections.ArrayList();

public string AddToCumulativeConcat(int index, string val, string notused)
{
	if (index < 0 || index >= myCumulativeConcatArray.Count)
	{
		return """";
	}
	myCumulativeConcatArray[index] = (string)(myCumulativeConcatArray[index]) + val;
	return myCumulativeConcatArray[index].ToString();
}

public string GetCumulativeConcat(int index)
{
	if (index < 0 || index >= myCumulativeConcatArray.Count)
	{
		return """";
	}
	return myCumulativeConcatArray[index].ToString();
}

public string StringConcat(string param0, string param1)
{
   return param0 + param1;
}


public int StringSize(string str)
{
	if (str == null)
	{
		return 0;
	}
	return str.Length;
}


public string MathSubtract(string param0, string param1)
{
	System.Collections.ArrayList listValues = new System.Collections.ArrayList();
	listValues.Add(param0);
	listValues.Add(param1);
	double ret = 0;
	bool first = true;
	foreach (string obj in listValues)
	{
		if (first)
		{
			first = false;
			double d = 0;
			if (IsNumeric(obj, ref d))
			{
				ret = d;
			}
			else
			{
				return """";
			}
		}
		else
		{
			double d = 0;
			if (IsNumeric(obj, ref d))
			{
				ret -= d;
			}
			else
			{
				return """";
			}
		}
	}
	return ret.ToString(System.Globalization.CultureInfo.InvariantCulture);
}


public string StringSubstring(string str, string left, string right)
{
	string retval = """";
	double dleft = 0;
	double dright = 0;
	if (str != null && IsNumeric(left, ref dleft) && IsNumeric(right, ref dright))
	{
		int lt = (int)dleft;
		int rt = (int)dright;
		lt--; rt--;
		if (lt >= 0 && rt >= lt && lt < str.Length)
		{
			if (rt < str.Length)
			{
				retval = str.Substring(lt, rt-lt+1);
			}
			else
			{
				retval = str.Substring(lt, str.Length-lt);
			}
		}
	}
	return retval;
}


public string RemoveLastComma(string input)
{
return input.Substring(0, input.Length-1);
}

public bool IsNumeric(string val)
{
	if (val == null)
	{
		return false;
	}
	double d = 0;
	return Double.TryParse(val, System.Globalization.NumberStyles.AllowThousands | System.Globalization.NumberStyles.Float, System.Globalization.CultureInfo.InvariantCulture, out d);
}

public bool IsNumeric(string val, ref double d)
{
	if (val == null)
	{
		return false;
	}
	return Double.TryParse(val, System.Globalization.NumberStyles.AllowThousands | System.Globalization.NumberStyles.Float, System.Globalization.CultureInfo.InvariantCulture, out d);
}


]]></msxsl:script>
</xsl:stylesheet>";
        
        private const string _strArgList = @"<ExtensionObjects />";
        
        private const string _strSrcSchemasList0 = @"MapCommaSeparatedValue.MultipleElementsSchema";
        
        private const string _strTrgSchemasList0 = @"MapCommaSeparatedValue.CommaSeparatedSchema";
        
        public override string XmlContent {
            get {
                return _strMap;
            }
        }
        
        public override string XsltArgumentListContent {
            get {
                return _strArgList;
            }
        }
        
        public override string[] SourceSchemas {
            get {
                string[] _SrcSchemas = new string [1];
                _SrcSchemas[0] = @"MapCommaSeparatedValue.MultipleElementsSchema";
                return _SrcSchemas;
            }
        }
        
        public override string[] TargetSchemas {
            get {
                string[] _TrgSchemas = new string [1];
                _TrgSchemas[0] = @"MapCommaSeparatedValue.CommaSeparatedSchema";
                return _TrgSchemas;
            }
        }
    }
}
